/* A Bison parser, made by GNU Bison 3.3.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.3.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 88 "calculator.y" /* yacc.c:337  */

#include "config.h"
#ifndef DIGITAL
 #include<stdio.h>
 #include<string.h>
 #include<stdlib.h> 
 #include<math.h>
#endif
#include "calculator.h"
#include "xmtnimage.h"

void addfunc(char *name, double(*func)(double));
void addfunc2(char *name, double(*func)(double,double));
void addfunc3(char *name, double(*func)(double,double,double));
void addfunc4(char *name, double(*func)(double,double,double,double));
void addfuncchar(char *name, double(*func)(char *));
void addfuncchar2(char *name, void(*func)(char*, char*));
double drand(double a); 
void skip_to_end(void);
void skip_to_end_of_line(void);
double dmax(double a, double b);
double dmin(double a, double b);
void print_number(FILE *stream, double number);
void print_string(FILE *stream, char *string);

int input(void);
int yyinput(void);
char *string(struct symtab *sym);
#ifndef MIPS
extern int yylex(void);
#endif
void yyerror(char *s);
void yyrestart ( FILE *input_file );

extern Globals     g;
extern Image      *z;
extern int         ci;
extern char yy_hold_char;
extern int yy_n_chars;
extern int ii,rr,gg,bb; 
extern char *text;
extern char *yytext;
extern int column;      /* where the error is */

extern char *yy_current_buffer;
extern int yy_init;     /* whether we need to initialize */
extern int yy_start;    /* start state number */
extern int status;
extern char *yy_c_buf_p;
int if_true=0, print_count, datatype;
int rr,gg,bb,v,x,y,xstart,ystart,xend,yend,frame,bpp,ino,len;
int lineno,k,comp,invert;
char *position=0;
int fff;
FILE *fp;
void *ptr;
static char filename[FILENAMELENGTH];
static char tempstring[128];

#line 131 "y.tab.c" /* yacc.c:337  */
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    NAME = 258,
    NUMBER = 259,
    YYSTRING = 260,
    IDENTIFIER = 261,
    EQ = 262,
    LE = 263,
    GE = 264,
    NE = 265,
    PLUS_EQUALS = 266,
    MINUS_EQUALS = 267,
    TIMES_EQUALS = 268,
    DIVIDE_EQUALS = 269,
    LOGICAL_AND = 270,
    LOGICAL_OR = 271,
    INCREMENT = 272,
    DECREMENT = 273,
    IMAGE = 274,
    RED = 275,
    GREEN = 276,
    BLUE = 277,
    YYREAL = 278,
    YYIMAG = 279,
    YYWAVE = 280,
    AREA = 281,
    DENSITY = 282,
    PRINT = 286,
    IF = 288,
    THEN = 289,
    ELSE = 290,
    CASE = 291,
    DEFAULT = 292,
    SWITCH = 293,
    WHILE = 294,
    DO = 295,
    FOR = 296,
    GOTO = 297,
    BREAK = 299,
    RETURN = 300,
    TOK_EMPTY_LINE = 301,
    UMINUS = 302
  };
#endif
/* Tokens.  */
#define NAME 258
#define NUMBER 259
#define YYSTRING 260
#define IDENTIFIER 261
#define EQ 262
#define LE 263
#define GE 264
#define NE 265
#define PLUS_EQUALS 266
#define MINUS_EQUALS 267
#define TIMES_EQUALS 268
#define DIVIDE_EQUALS 269
#define LOGICAL_AND 270
#define LOGICAL_OR 271
#define INCREMENT 272
#define DECREMENT 273
#define IMAGE 274
#define RED 275
#define GREEN 276
#define BLUE 277
#define YYREAL 278
#define YYIMAG 279
#define YYWAVE 280
#define AREA 281
#define PRINT 286
#define IF 288
#define THEN 289
#define ELSE 290
#define CASE 291
#define DEFAULT 292
#define SWITCH 293
#define WHILE 294
#define DO 295
#define FOR 296
#define GOTO 297
#define BREAK 299
#define RETURN 300
#define TOK_EMPTY_LINE 301
#define UMINUS 302

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 149 "calculator.y" /* yacc.c:352  */
  double dval;
          struct symtab *symp;
       

#line 273 "y.tab.c" /* yacc.c:352  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  71
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1663

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  70
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  21
/* YYNRULES -- Number of rules.  */
#define YYNRULES  87
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  262

#define YYUNDEFTOK  2
#define YYMAXUTOK   302

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      66,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    57,     2,    67,     2,     2,    47,     2,
      63,    64,    54,    53,    65,    52,     2,    55,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    62,
      50,    61,    51,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    68,     2,    69,    49,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    59,    48,    60,    58,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    56
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   183,   183,   184,   185,   186,   187,   192,   191,   198,
     197,   200,   201,   202,   204,   203,   208,   208,   209,   209,
     210,   210,   212,   211,   217,   217,   218,   218,   219,   219,
     220,   221,   228,   235,   240,   241,   242,   243,   247,   248,
     249,   250,   251,   255,   256,   261,   262,   263,   264,   268,
     269,   270,   271,   275,   279,   280,   281,   282,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   315,   325,   335,   345,
     361,   376,   389,   404,   419,   434,   445,   456
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NAME", "NUMBER", "YYSTRING",
  "IDENTIFIER", "EQ", "LE", "GE", "NE", "PLUS_EQUALS", "MINUS_EQUALS",
  "TIMES_EQUALS", "DIVIDE_EQUALS", "LOGICAL_AND", "LOGICAL_OR",
  "INCREMENT", "DECREMENT", "IMAGE", "RED", "GREEN", "BLUE", "YYREAL",
  "YYIMAG", "YYWAVE", "AREA", "DENSITY",
  "PRINT", "IF", "THEN", "ELSE", "CASE",
  "DEFAULT", "SWITCH", "WHILE", "DO", "FOR", "GOTO", "TNI_CONTINUE",
  "BREAK", "RETURN", "TOK_EMPTY_LINE", "'&'", "'|'", "'^'", "'<'", "'>'",
  "'-'", "'+'", "'*'", "'/'", "UMINUS", "'!'", "'~'", "'{'", "'}'", "'='",
  "';'", "'('", "')'", "','", "'\\n'", "'#'", "'['", "']'", "$accept",
  "statement_list", "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6",
  "$@7", "$@8", "$@9", "$@10", "comment", "iteration_statement",
  "jump_statement", "identifier_list", "print_list", "write_list",
  "identifier", "expression", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    38,   124,    94,
      60,    62,    45,    43,    42,    47,   302,    33,   126,   123,
     125,    61,    59,    40,    41,    44,    10,    35,    91,    93
};
# endif

#define YYPACT_NINF -65

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-65)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     261,    97,   -65,   -65,   -64,   -56,   -36,   -33,   -31,   -30,
     -25,   -24,   -18,   -17,   -13,   -65,   -12,   361,     5,    63,
       8,     9,    70,   161,   161,   161,   261,   161,   -65,   -65,
     211,   -65,   -65,   -65,   -65,     7,   -65,  1598,   161,   161,
     161,   161,   -65,   -65,  1100,  1156,   161,   161,   161,   161,
     161,   161,   161,   161,    72,  1165,   161,   361,    36,   361,
      34,   -65,   -65,    35,   -65,  1582,   -65,   -65,   -65,   311,
    1396,   -65,   -65,    63,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,    37,
    1598,  1598,  1598,  1598,    38,    40,   -65,  1598,    39,  1307,
      32,   400,   413,   423,   478,   488,   501,   551,   -65,   -65,
     -54,  1598,  1446,    41,    43,   361,   -65,   -65,   361,   -65,
     -65,   -46,   -46,   -46,   -46,  1608,  1608,  1413,  1413,  1413,
     -46,   -46,   -40,   -40,   -65,   -65,   -65,    42,    45,    50,
      51,   -65,   -65,    54,    55,   -65,   -65,   161,    52,    53,
      56,    58,    61,    62,    67,    73,    66,    57,  1221,   -65,
     361,   161,  1090,   -65,   -65,   -65,   -65,   -65,   -65,   -65,
    1326,   161,   161,   161,   161,   161,   161,   161,   161,  1230,
     -65,   -65,  1598,   -65,  1464,   361,  1514,   -65,   161,   564,
     574,   629,   639,   652,   702,   715,   725,   -65,   -44,  1598,
      76,   -65,   361,  1377,    74,    75,    77,    78,    79,    80,
      91,    93,    82,  1286,   -65,   -65,   -65,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   -65,   -65,  1598,  1532,
     780,   790,   803,   853,   866,   876,   931,   941,   -65,    94,
      95,    99,   100,   -65,   -65,   -65,   101,   161,   161,   161,
     161,   161,   954,  1004,  1017,  1027,  1082,   -65,   -65,   -65,
     -65,   -65
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    74,    73,    53,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    32,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    30,    33,
       0,     2,     4,    11,    12,     3,    43,    28,     0,     0,
       0,     0,    24,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    39,    40,    74,    41,     0,    58,    59,    60,     0,
       0,     1,     5,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    18,    20,    22,     0,     0,     9,     7,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    14,    48,
       0,    47,     0,     0,     0,     0,    38,    42,     0,    61,
      44,    66,    64,    65,    67,    68,    69,    70,    71,    72,
      62,    63,    55,    54,    56,    57,    29,     0,     0,     0,
       0,    25,    27,     0,     0,    79,    75,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    31,
       0,     0,     0,     6,    17,    19,    21,    23,    10,     8,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      13,    46,    45,    34,     0,     0,     0,    76,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    52,     0,    51,
       0,    36,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    37,    77,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    15,    50,    49,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    78,     0,
       0,     0,     0,    85,    86,    87,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    81,    82,    83,
      84,    80
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -65,    92,    19,   -65,   -65,   -65,   -65,   -65,   -65,   -65,
     -65,   -65,   -65,   -65,   -65,   -65,   -65,   -65,   -65,    -6,
     -22
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    30,    31,   144,   143,   156,   137,   138,   139,   140,
      94,    95,    89,    32,    33,    34,    35,   110,   198,    36,
      37
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint16 yytable[] =
{
      65,    66,    67,    68,    46,    70,    85,    86,    87,    88,
     157,   158,    47,    60,    87,    88,    90,    91,    92,    93,
     212,   213,    97,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    48,   111,   112,    49,    58,    50,    51,    74,
      75,    76,    77,    52,    53,    54,    55,    78,    79,    72,
      56,    57,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   120,    59,     3,
      61,    62,    73,    63,     2,   114,   113,   108,   115,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    72,     4,
       5,     6,     7,     8,     9,    10,   116,    11,    45,   136,
     141,   148,   142,   145,   164,   160,   161,   165,    38,    39,
      40,    41,   166,   167,    42,    43,   168,   169,    69,   180,
     171,   172,    23,     0,   173,   170,   174,    24,    25,   175,
     176,   179,    64,    27,   162,   177,   182,   163,   214,   184,
     186,   178,   218,   219,   226,   220,   221,   222,   223,   189,
     190,   191,   192,   193,   194,   195,   196,   199,    44,   224,
      45,   225,   247,   248,    63,     2,   203,   249,   250,   251,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   183,
       4,     5,     6,     7,     8,     9,    10,     0,    11,     0,
       0,   228,     0,     0,     0,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   201,     0,     0,     0,     0,     0,
       0,    71,     0,    23,     1,     2,     0,     0,    24,    25,
       0,   215,     0,     0,    27,   252,   253,   254,   255,   256,
       4,     5,     6,     7,     8,     9,    10,     0,    11,     0,
       0,    12,    13,     0,    14,     0,    15,     0,     0,     0,
      16,    17,    18,    19,    20,    21,    22,     0,     0,     0,
       0,     0,     0,    23,     1,     2,     0,     3,    24,    25,
       0,     0,     0,     0,    27,     0,     0,    28,     0,     0,
       4,     5,     6,     7,     8,     9,    10,     0,    11,     0,
       0,    12,    13,     0,    14,     0,    15,     0,     0,     0,
      16,    17,    18,    19,    20,    21,    22,     0,     0,     0,
       0,     0,     0,    23,     1,     2,     0,     0,    24,    25,
      26,     0,     0,     0,    27,     0,     0,    28,    29,     0,
       4,     5,     6,     7,     8,     9,    10,     0,    11,     0,
       0,    12,    13,     0,    14,     0,    15,     0,     0,     0,
      16,    17,    18,    19,    20,    21,    22,     0,     0,     0,
       0,     0,     0,    23,     1,     2,     0,     0,    24,    25,
       0,   118,     0,     0,    27,     0,     0,    28,     0,     0,
       4,     5,     6,     7,     8,     9,    10,     0,    11,     0,
       0,    12,    13,     0,    14,     0,    15,     0,     0,     0,
      16,    17,    18,    19,    20,    21,    22,    74,    75,    76,
      77,     0,     0,    23,     0,    78,    79,     0,    24,    25,
      74,    75,    76,    77,    27,     0,     0,    28,    78,    79,
      74,    75,    76,    77,     0,     0,     0,     0,    78,    79,
       0,     0,     0,     0,     0,     0,     0,    80,    81,    82,
      83,    84,    85,    86,    87,    88,     0,     0,     0,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,   149,
      80,    81,    82,    83,    84,    85,    86,    87,    88,     0,
       0,     0,   150,     0,     0,    74,    75,    76,    77,     0,
       0,     0,   151,    78,    79,    74,    75,    76,    77,     0,
       0,     0,     0,    78,    79,     0,     0,     0,    74,    75,
      76,    77,     0,     0,     0,     0,    78,    79,     0,     0,
       0,     0,     0,     0,     0,    80,    81,    82,    83,    84,
      85,    86,    87,    88,     0,    80,    81,    82,    83,    84,
      85,    86,    87,    88,     0,     0,     0,   152,    80,    81,
      82,    83,    84,    85,    86,    87,    88,   153,    74,    75,
      76,    77,     0,     0,     0,     0,    78,    79,     0,     0,
     154,    74,    75,    76,    77,     0,     0,     0,     0,    78,
      79,    74,    75,    76,    77,     0,     0,     0,     0,    78,
      79,     0,     0,     0,     0,     0,     0,     0,    80,    81,
      82,    83,    84,    85,    86,    87,    88,     0,     0,     0,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
     155,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       0,     0,     0,   204,     0,     0,    74,    75,    76,    77,
       0,     0,     0,   205,    78,    79,    74,    75,    76,    77,
       0,     0,     0,     0,    78,    79,     0,     0,     0,    74,
      75,    76,    77,     0,     0,     0,     0,    78,    79,     0,
       0,     0,     0,     0,     0,     0,    80,    81,    82,    83,
      84,    85,    86,    87,    88,     0,    80,    81,    82,    83,
      84,    85,    86,    87,    88,     0,     0,     0,   206,    80,
      81,    82,    83,    84,    85,    86,    87,    88,   207,    74,
      75,    76,    77,     0,     0,     0,     0,    78,    79,     0,
       0,   208,    74,    75,    76,    77,     0,     0,     0,     0,
      78,    79,    74,    75,    76,    77,     0,     0,     0,     0,
      78,    79,     0,     0,     0,     0,     0,     0,     0,    80,
      81,    82,    83,    84,    85,    86,    87,    88,     0,     0,
       0,     0,    80,    81,    82,    83,    84,    85,    86,    87,
      88,   209,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     0,     0,     0,   210,     0,     0,    74,    75,    76,
      77,     0,     0,     0,   211,    78,    79,    74,    75,    76,
      77,     0,     0,     0,     0,    78,    79,     0,     0,     0,
      74,    75,    76,    77,     0,     0,     0,     0,    78,    79,
       0,     0,     0,     0,     0,     0,     0,    80,    81,    82,
      83,    84,    85,    86,    87,    88,     0,    80,    81,    82,
      83,    84,    85,    86,    87,    88,     0,     0,     0,   239,
      80,    81,    82,    83,    84,    85,    86,    87,    88,   240,
      74,    75,    76,    77,     0,     0,     0,     0,    78,    79,
       0,     0,   241,    74,    75,    76,    77,     0,     0,     0,
       0,    78,    79,    74,    75,    76,    77,     0,     0,     0,
       0,    78,    79,     0,     0,     0,     0,     0,     0,     0,
      80,    81,    82,    83,    84,    85,    86,    87,    88,     0,
       0,     0,     0,    80,    81,    82,    83,    84,    85,    86,
      87,    88,   242,    80,    81,    82,    83,    84,    85,    86,
      87,    88,     0,     0,     0,   243,     0,     0,    74,    75,
      76,    77,     0,     0,     0,   244,    78,    79,    74,    75,
      76,    77,     0,     0,     0,     0,    78,    79,     0,     0,
       0,    74,    75,    76,    77,     0,     0,     0,     0,    78,
      79,     0,     0,     0,     0,     0,     0,     0,    80,    81,
      82,    83,    84,    85,    86,    87,    88,     0,    80,    81,
      82,    83,    84,    85,    86,    87,    88,     0,     0,     0,
     245,    80,    81,    82,    83,    84,    85,    86,    87,    88,
     246,    74,    75,    76,    77,     0,     0,     0,     0,    78,
      79,     0,     0,   257,    74,    75,    76,    77,     0,     0,
       0,     0,    78,    79,    74,    75,    76,    77,     0,     0,
       0,     0,    78,    79,     0,     0,     0,     0,     0,     0,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       0,     0,     0,     0,    80,    81,    82,    83,    84,    85,
      86,    87,    88,   258,    80,    81,    82,    83,    84,    85,
      86,    87,    88,     0,     0,     0,   259,     0,     0,    74,
      75,    76,    77,    63,     2,     0,   260,    78,    79,     0,
       0,     0,     0,    63,     2,    96,     0,     0,     0,     4,
       5,     6,     7,     8,     9,    10,     0,    11,     0,     4,
       5,     6,     7,     8,     9,    10,     0,    11,     0,    80,
      81,    82,    83,    84,    85,    86,    87,    88,     0,     0,
       0,     0,    23,     0,     0,     0,     0,    24,    25,     0,
       0,   261,    23,    27,   185,     0,     0,    24,    25,    63,
       2,    98,     0,    27,     0,     0,     0,     0,    63,     2,
     109,     0,     0,     0,     0,     4,     5,     6,     7,     8,
       9,    10,     0,    11,     4,     5,     6,     7,     8,     9,
      10,     0,    11,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    23,     0,
       0,     0,     0,    24,    25,     0,     0,    23,     0,    27,
       0,     0,    24,    25,    63,     2,   181,     0,    27,     0,
       0,     0,     0,    63,     2,   197,     0,     0,     0,     0,
       4,     5,     6,     7,     8,     9,    10,     0,    11,     4,
       5,     6,     7,     8,     9,    10,     0,    11,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    23,     0,     0,     0,     0,    24,    25,
       0,     0,    23,     0,    27,     0,     0,    24,    25,    63,
       2,   227,     0,    27,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     4,     5,     6,     7,     8,
       9,    10,     0,    11,    74,    75,    76,    77,     0,     0,
       0,     0,    78,    79,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    74,    75,    76,    77,     0,    23,     0,
       0,    78,    79,    24,    25,     0,     0,     0,     0,    27,
       0,     0,     0,     0,    80,    81,    82,    83,    84,    85,
      86,    87,    88,     0,     0,     0,     0,     0,     0,     0,
       0,   146,   147,    80,    81,    82,    83,    84,    85,    86,
      87,    88,     0,     0,    74,    75,    76,    77,     0,     0,
     187,   188,    78,    79,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    74,    75,    76,    77,     0,     0,     0,
       0,    78,    79,     0,     0,     0,     0,     0,     0,     0,
      74,    75,    76,    77,    80,    81,    82,    83,    84,    85,
      86,    87,    88,     0,     0,     0,     0,     0,     0,     0,
       0,   216,   217,    80,    81,    82,    83,    84,    85,    86,
      87,    88,     0,    74,    75,    76,    77,     0,     0,     0,
     119,    78,    79,    83,    84,    85,    86,    87,    88,     0,
       0,    74,    75,    76,    77,     0,     0,     0,     0,    78,
      79,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    80,    81,    82,    83,    84,    85,    86,
      87,    88,     0,     0,     0,     0,     0,     0,     0,     0,
     159,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       0,    74,    75,    76,    77,     0,     0,     0,   200,    78,
      79,     0,     0,     0,     0,     0,     0,     0,     0,    74,
      75,    76,    77,     0,     0,     0,     0,    78,    79,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       0,     0,     0,     0,     0,     0,     0,     0,   202,    80,
      81,    82,    83,    84,    85,    86,    87,    88,     0,    74,
      75,    76,    77,     0,     0,     0,   238,    78,    79,     0,
       0,     0,     0,     0,     0,    74,    75,    76,    77,     0,
       0,     0,     0,    78,    79,    74,    75,    76,    77,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    80,
      81,    82,    83,    84,    85,    86,    87,    88,     0,     0,
       0,     0,     0,     0,   117,    80,    81,    82,    83,    84,
      85,    86,    87,    88,     0,    80,    81,    82,    83,    84,
      85,    86,    87,    88
};

static const yytype_int16 yycheck[] =
{
      22,    23,    24,    25,    68,    27,    52,    53,    54,    55,
      64,    65,    68,    19,    54,    55,    38,    39,    40,    41,
      64,    65,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    68,    55,    56,    68,    17,    68,    68,     7,
       8,     9,    10,    68,    68,    63,    63,    15,    16,    30,
      63,    63,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    73,    63,     6,
      62,    62,    65,     3,     4,    39,    57,     5,    59,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    69,    19,
      20,    21,    22,    23,    24,    25,    62,    27,    63,    62,
      62,    69,    62,    64,    62,    64,    63,    62,    11,    12,
      13,    14,    62,    62,    17,    18,    62,    62,    26,    62,
      68,    68,    52,    -1,    68,   147,    68,    57,    58,    68,
      68,    65,    62,    63,   115,    68,   158,   118,    62,   161,
     162,    68,    68,    68,    62,    68,    68,    68,    68,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    61,    68,
      63,    68,    68,    68,     3,     4,   188,    68,    68,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   160,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    -1,
      -1,   213,    -1,    -1,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   185,    -1,    -1,    -1,    -1,    -1,
      -1,     0,    -1,    52,     3,     4,    -1,    -1,    57,    58,
      -1,   202,    -1,    -1,    63,   247,   248,   249,   250,   251,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    -1,
      -1,    30,    31,    -1,    33,    -1,    35,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,     3,     4,    -1,     6,    57,    58,
      -1,    -1,    -1,    -1,    63,    -1,    -1,    66,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    -1,
      -1,    30,    31,    -1,    33,    -1,    35,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,     3,     4,    -1,    -1,    57,    58,
      59,    -1,    -1,    -1,    63,    -1,    -1,    66,    67,    -1,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    -1,
      -1,    30,    31,    -1,    33,    -1,    35,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,     3,     4,    -1,    -1,    57,    58,
      -1,    60,    -1,    -1,    63,    -1,    -1,    66,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    -1,
      -1,    30,    31,    -1,    33,    -1,    35,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,     7,     8,     9,
      10,    -1,    -1,    52,    -1,    15,    16,    -1,    57,    58,
       7,     8,     9,    10,    63,    -1,    -1,    66,    15,    16,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    69,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    69,    -1,    -1,     7,     8,     9,    10,    -1,
      -1,    -1,    69,    15,    16,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    -1,    -1,    -1,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    -1,    69,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    69,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,    -1,
      69,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      69,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    69,    -1,    -1,     7,     8,     9,    10,
      -1,    -1,    -1,    69,    15,    16,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    -1,    -1,    -1,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    -1,    69,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    69,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      -1,    69,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    69,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    69,    -1,    -1,     7,     8,     9,
      10,    -1,    -1,    -1,    69,    15,    16,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    -1,    -1,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    69,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    69,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      -1,    -1,    69,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    69,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    69,    -1,    -1,     7,     8,
       9,    10,    -1,    -1,    -1,    69,    15,    16,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,    -1,
      -1,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      69,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      69,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    -1,    -1,    69,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    69,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    69,    -1,    -1,     7,
       8,     9,    10,     3,     4,    -1,    69,    15,    16,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    -1,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    57,    58,    -1,
      -1,    69,    52,    63,    64,    -1,    -1,    57,    58,     3,
       4,     5,    -1,    63,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,    -1,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,    19,    20,    21,    22,    23,    24,
      25,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    57,    58,    -1,    -1,    52,    -1,    63,
      -1,    -1,    57,    58,     3,     4,     5,    -1,    63,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    -1,    27,    19,
      20,    21,    22,    23,    24,    25,    -1,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    57,    58,
      -1,    -1,    52,    -1,    63,    -1,    -1,    57,    58,     3,
       4,     5,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    -1,    27,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     7,     8,     9,    10,    -1,    52,    -1,
      -1,    15,    16,    57,    58,    -1,    -1,    -1,    -1,    63,
      -1,    -1,    -1,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    65,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,     7,     8,     9,    10,    -1,    -1,
      64,    65,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       7,     8,     9,    10,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    65,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,     7,     8,     9,    10,    -1,    -1,    -1,
      64,    15,    16,    50,    51,    52,    53,    54,    55,    -1,
      -1,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,     7,     8,     9,    10,    -1,    -1,    -1,    64,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,     7,
       8,     9,    10,    -1,    -1,    -1,    64,    15,    16,    -1,
      -1,    -1,    -1,    -1,    -1,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    62,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     6,    19,    20,    21,    22,    23,    24,
      25,    27,    30,    31,    33,    35,    39,    40,    41,    42,
      43,    44,    45,    52,    57,    58,    59,    63,    66,    67,
      71,    72,    83,    84,    85,    86,    89,    90,    11,    12,
      13,    14,    17,    18,    61,    63,    68,    68,    68,    68,
      68,    68,    68,    68,    63,    63,    63,    63,    72,    63,
      89,    62,    62,     3,    62,    90,    90,    90,    90,    71,
      90,     0,    72,    65,     7,     8,     9,    10,    15,    16,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    82,
      90,    90,    90,    90,    80,    81,     5,    90,     5,    90,
      90,    90,    90,    90,    90,    90,    90,    90,     5,     5,
      87,    90,    90,    72,    39,    72,    62,    62,    60,    64,
      89,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    62,    76,    77,    78,
      79,    62,    62,    74,    73,    64,    64,    65,    69,    69,
      69,    69,    69,    69,    69,    69,    75,    64,    65,    64,
      64,    63,    72,    72,    62,    62,    62,    62,    62,    62,
      90,    68,    68,    68,    68,    68,    68,    68,    68,    65,
      62,     5,    90,    72,    90,    64,    90,    64,    65,    90,
      90,    90,    90,    90,    90,    90,    90,     5,    88,    90,
      64,    72,    64,    90,    69,    69,    69,    69,    69,    69,
      69,    69,    64,    65,    62,    72,    64,    65,    68,    68,
      68,    68,    68,    68,    68,    68,    62,     5,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    64,    69,
      69,    69,    69,    69,    69,    69,    69,    68,    68,    68,
      68,    68,    90,    90,    90,    90,    90,    69,    69,    69,
      69,    69
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    70,    71,    71,    71,    71,    71,    73,    72,    74,
      72,    72,    72,    72,    75,    72,    76,    72,    77,    72,
      78,    72,    79,    72,    80,    72,    81,    72,    82,    72,
      72,    72,    72,    83,    84,    84,    84,    84,    85,    85,
      85,    85,    85,    86,    86,    87,    87,    87,    87,    88,
      88,    88,    88,    89,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     2,     4,     0,     5,     0,
       5,     1,     1,     5,     0,     8,     0,     5,     0,     5,
       0,     5,     0,     5,     0,     4,     0,     4,     0,     3,
       1,     4,     1,     1,     5,     7,     6,     7,     3,     2,
       2,     2,     3,     1,     3,     3,     3,     1,     1,     3,
       3,     1,     1,     1,     3,     3,     3,     3,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     4,     6,     8,    10,     4,
      13,    13,    13,    13,    13,    10,    10,    10
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 192 "calculator.y" /* yacc.c:1652  */
    {    (yyvsp[-2].symp)->value = (yyvsp[0].dval); 
                     read_variable((char*)"temp", tempstring, (yyvsp[-2].symp)->datatype); 
                     if((yyvsp[-2].symp)->datatype == STRING)
                          add_string_variable((char*)(yyvsp[-2].symp)->name, (char*)tempstring, 0);
                }
#line 1818 "y.tab.c" /* yacc.c:1652  */
    break;

  case 9:
#line 198 "calculator.y" /* yacc.c:1652  */
    {    add_string_variable((yyvsp[-2].symp)->name, string((yyvsp[0].symp)), 0); 
                }
#line 1825 "y.tab.c" /* yacc.c:1652  */
    break;

  case 14:
#line 204 "calculator.y" /* yacc.c:1652  */
    {    strncpy(filename, string((yyvsp[0].symp)), 128);  
                     ptr = read_ptr(filename);
                     fp = (FILE*)ptr;
                }
#line 1834 "y.tab.c" /* yacc.c:1652  */
    break;

  case 16:
#line 208 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-2].symp)->value += (yyvsp[0].dval); }
#line 1840 "y.tab.c" /* yacc.c:1652  */
    break;

  case 18:
#line 209 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-2].symp)->value -= (yyvsp[0].dval); }
#line 1846 "y.tab.c" /* yacc.c:1652  */
    break;

  case 20:
#line 210 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-2].symp)->value *= (yyvsp[0].dval); }
#line 1852 "y.tab.c" /* yacc.c:1652  */
    break;

  case 22:
#line 212 "calculator.y" /* yacc.c:1652  */
    { if ((yyvsp[0].dval) == 0.0)
                              yyerror((char*)"Division by zero");
                          else
                              (yyvsp[-2].symp)->value /= (yyvsp[0].dval);
                        }
#line 1862 "y.tab.c" /* yacc.c:1652  */
    break;

  case 24:
#line 217 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-1].symp)->value++; }
#line 1868 "y.tab.c" /* yacc.c:1652  */
    break;

  case 26:
#line 218 "calculator.y" /* yacc.c:1652  */
    { (yyvsp[-1].symp)->value--; }
#line 1874 "y.tab.c" /* yacc.c:1652  */
    break;

  case 28:
#line 219 "calculator.y" /* yacc.c:1652  */
    { add_variable((char*)"temp", (yyvsp[0].dval)); }
#line 1880 "y.tab.c" /* yacc.c:1652  */
    break;

  case 31:
#line 222 "calculator.y" /* yacc.c:1652  */
    {
                   if( (yyvsp[-1].dval) == 1)  if_true=1;                               
                   else        {  if_true=0;
                                  skip_to_end();
                               }
                }
#line 1891 "y.tab.c" /* yacc.c:1652  */
    break;

  case 32:
#line 229 "calculator.y" /* yacc.c:1652  */
    {  
                   if(if_true) skip_to_end(); 
                }
#line 1899 "y.tab.c" /* yacc.c:1652  */
    break;

  case 33:
#line 235 "calculator.y" /* yacc.c:1652  */
    { skip_to_end_of_line(); }
#line 1905 "y.tab.c" /* yacc.c:1652  */
    break;

  case 45:
#line 261 "calculator.y" /* yacc.c:1652  */
    { print_number(stdout, (yyvsp[0].dval)); }
#line 1911 "y.tab.c" /* yacc.c:1652  */
    break;

  case 46:
#line 262 "calculator.y" /* yacc.c:1652  */
    { print_string(stdout, string((yyvsp[0].symp))); }
#line 1917 "y.tab.c" /* yacc.c:1652  */
    break;

  case 47:
#line 263 "calculator.y" /* yacc.c:1652  */
    { print_number(stdout, (yyvsp[0].dval)); }
#line 1923 "y.tab.c" /* yacc.c:1652  */
    break;

  case 48:
#line 264 "calculator.y" /* yacc.c:1652  */
    { print_string(stdout, string((yyvsp[0].symp))); }
#line 1929 "y.tab.c" /* yacc.c:1652  */
    break;

  case 49:
#line 268 "calculator.y" /* yacc.c:1652  */
    { print_number(fp, (yyvsp[0].dval)); }
#line 1935 "y.tab.c" /* yacc.c:1652  */
    break;

  case 50:
#line 269 "calculator.y" /* yacc.c:1652  */
    { print_string(fp, string((yyvsp[0].symp))); }
#line 1941 "y.tab.c" /* yacc.c:1652  */
    break;

  case 51:
#line 270 "calculator.y" /* yacc.c:1652  */
    { print_number(fp, (yyvsp[0].dval));  }
#line 1947 "y.tab.c" /* yacc.c:1652  */
    break;

  case 52:
#line 271 "calculator.y" /* yacc.c:1652  */
    {  print_string(fp, string((yyvsp[0].symp))); }
#line 1953 "y.tab.c" /* yacc.c:1652  */
    break;

  case 54:
#line 279 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) + (yyvsp[0].dval); }
#line 1959 "y.tab.c" /* yacc.c:1652  */
    break;

  case 55:
#line 280 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) - (yyvsp[0].dval); }
#line 1965 "y.tab.c" /* yacc.c:1652  */
    break;

  case 56:
#line 281 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) * (yyvsp[0].dval); }
#line 1971 "y.tab.c" /* yacc.c:1652  */
    break;

  case 57:
#line 283 "calculator.y" /* yacc.c:1652  */
    { if ((yyvsp[0].dval) == 0.0)
{
//// hangs cinnamon if it gets to here
printf("Fatal error, division by zero\n");
g.getout=2;
return(-1);
                              yyerror((char*)"Division by zero");
}
                          else
                              (yyval.dval) = (yyvsp[-2].dval) / (yyvsp[0].dval); 
                        }
#line 1981 "y.tab.c" /* yacc.c:1652  */
    break;

  case 58:
#line 288 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = -(yyvsp[0].dval); }
#line 1987 "y.tab.c" /* yacc.c:1652  */
    break;

  case 59:
#line 289 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = !(yyvsp[0].dval); }
#line 1993 "y.tab.c" /* yacc.c:1652  */
    break;

  case 60:
#line 290 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (double)(~(int)(yyvsp[0].dval)); }
#line 1999 "y.tab.c" /* yacc.c:1652  */
    break;

  case 61:
#line 291 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-1].dval); }
#line 2005 "y.tab.c" /* yacc.c:1652  */
    break;

  case 62:
#line 292 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) < (yyvsp[0].dval); }
#line 2011 "y.tab.c" /* yacc.c:1652  */
    break;

  case 63:
#line 293 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) > (yyvsp[0].dval); }
#line 2017 "y.tab.c" /* yacc.c:1652  */
    break;

  case 64:
#line 294 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) <= (yyvsp[0].dval); }
#line 2023 "y.tab.c" /* yacc.c:1652  */
    break;

  case 65:
#line 295 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) >= (yyvsp[0].dval); }
#line 2029 "y.tab.c" /* yacc.c:1652  */
    break;

  case 66:
#line 296 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) == (yyvsp[0].dval); }
#line 2035 "y.tab.c" /* yacc.c:1652  */
    break;

  case 67:
#line 297 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) != (yyvsp[0].dval); }
#line 2041 "y.tab.c" /* yacc.c:1652  */
    break;

  case 68:
#line 298 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) && (yyvsp[0].dval); }
#line 2047 "y.tab.c" /* yacc.c:1652  */
    break;

  case 69:
#line 299 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (yyvsp[-2].dval) || (yyvsp[0].dval); }
#line 2053 "y.tab.c" /* yacc.c:1652  */
    break;

  case 70:
#line 300 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (double)((int)(yyvsp[-2].dval) & (int)(yyvsp[0].dval)); }
#line 2059 "y.tab.c" /* yacc.c:1652  */
    break;

  case 71:
#line 301 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (double)((int)(yyvsp[-2].dval) | (int)(yyvsp[0].dval)); }
#line 2065 "y.tab.c" /* yacc.c:1652  */
    break;

  case 72:
#line 302 "calculator.y" /* yacc.c:1652  */
    { (yyval.dval) = (double)((int)(yyvsp[-2].dval) ^ (int)(yyvsp[0].dval)); }
#line 2071 "y.tab.c" /* yacc.c:1652  */
    break;

  case 74:
#line 304 "calculator.y" /* yacc.c:1652  */
    {  (yyval.dval) = (yyvsp[0].symp)->value; }
#line 2077 "y.tab.c" /* yacc.c:1652  */
    break;

  case 75:
#line 306 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-3].symp)->funcptr1)          /* func using a regular variable */
                        (yyval.dval) = ((yyvsp[-3].symp)->funcptr1)((yyvsp[-1].dval));
                    else
                    {   sprintf(tempstring, "%s is not a 1-argument function\n", (yyvsp[-3].symp)->name);
                        yyerror(tempstring);
                        (yyval.dval) = 0.0;
                    }
                 }
#line 2091 "y.tab.c" /* yacc.c:1652  */
    break;

  case 76:
#line 316 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-5].symp)->funcptr2)
                        (yyval.dval) = ((yyvsp[-5].symp)->funcptr2)((yyvsp[-3].dval),(yyvsp[-1].dval));
                    else
                    {   sprintf(tempstring, "%s is not a 2-argument function\n", (yyvsp[-5].symp)->name);
                        yyerror(tempstring);
                        (yyval.dval) = 0.0;
                    }
                 }
#line 2105 "y.tab.c" /* yacc.c:1652  */
    break;

  case 77:
#line 326 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-7].symp)->funcptr3)
                        (yyval.dval) = ((yyvsp[-7].symp)->funcptr3)((yyvsp[-5].dval),(yyvsp[-3].dval),(yyvsp[-1].dval));
                    else
                    {   sprintf(tempstring, "%s is not a 3-argument function\n", (yyvsp[-7].symp)->name);
                        yyerror(tempstring);
                        (yyval.dval) = 0.0;
                    }
                 }
#line 2119 "y.tab.c" /* yacc.c:1652  */
    break;

  case 78:
#line 336 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-9].symp)->funcptr4)
                        (yyval.dval) = ((yyvsp[-9].symp)->funcptr4)((yyvsp[-7].dval),(yyvsp[-5].dval),(yyvsp[-3].dval),(yyvsp[-1].dval));
                    else
                    {   sprintf(tempstring, "%s is not a 4-argument function\n", (yyvsp[-9].symp)->name);
                        yyerror(tempstring);
                        (yyval.dval) = 0.0;
                    }
                 }
#line 2133 "y.tab.c" /* yacc.c:1652  */
    break;

  case 79:
#line 346 "calculator.y" /* yacc.c:1652  */
    {  
                    if((yyvsp[-3].symp)->funcptrchar)
                    {   (yyval.dval) = ((yyvsp[-3].symp)->funcptrchar)(string((yyvsp[-1].symp)));
                        status = GOTNEW;       /* Break out of pixel loop */
                    }else if((yyvsp[-3].symp)->funcptrchar2) /* func using a string variable  */
                    {   ((yyvsp[-3].symp)->funcptrchar2) (string((yyvsp[-1].symp)), tempstring); 
                        add_string_variable((char*)"temp", tempstring, 0);
                        (yyvsp[-3].symp)->datatype = STRING;
                        status = GOTNEW;       /* Break out of pixel loop */
                    }else
                    {   sprintf(tempstring, "%s: error executing function\n", (yyvsp[-3].symp)->name);
                        yyerror(tempstring);
                        (yyval.dval) = 0.0;
                    }
                 }
#line 2153 "y.tab.c" /* yacc.c:1652  */
    break;

  case 80:
#line 362 "calculator.y" /* yacc.c:1652  */
    {    ino    = (int) (yyvsp[-10].dval);
                     frame  = (int) (yyvsp[-7].dval);
                     x      = (int) (yyvsp[-4].dval);
                     y      = (int) (yyvsp[-1].dval);
                     comp   = (int)read_variable((char*)"COMPENSATE", NULL, datatype);
                     invert = (int)read_variable((char*)"INVERT", NULL, datatype);
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     { 
                        (yyval.dval) = pixeldensity_image(x, y, ino, frame, comp, invert); 
                     }else yyerror((char*)"Array out of bounds");
                }
#line 2172 "y.tab.c" /* yacc.c:1652  */
    break;

  case 81:
#line 377 "calculator.y" /* yacc.c:1652  */
    {    ino   = (int) (yyvsp[-10].dval);
                     frame = (int) (yyvsp[-7].dval);
                     x     = (int) (yyvsp[-4].dval);
                     y     = (int) (yyvsp[-1].dval);
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     {  bpp   = z[ino].bpp;
                        (yyval.dval) = (double)(pixelat(z[ino].image[frame][y] + x*g.off[bpp], bpp)); 
                     }else yyerror((char*)"Array out of bounds");
                }
#line 2189 "y.tab.c" /* yacc.c:1652  */
    break;

  case 82:
#line 390 "calculator.y" /* yacc.c:1652  */
    {    ino   = (int) (yyvsp[-10].dval);
                     frame = (int) (yyvsp[-7].dval);
                     x     = (int) (yyvsp[-4].dval);
                     y     = (int) (yyvsp[-1].dval);
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     {  bpp   = z[ino].bpp;
                        v = pixelat(z[ino].image[frame][y] + x*g.off[bpp], bpp); 
                        valuetoRGB(v,rr,gg,bb,bpp);
                        (yyval.dval) = (double)rr;
                     }else yyerror((char*)"Array out of bounds");
                }
#line 2208 "y.tab.c" /* yacc.c:1652  */
    break;

  case 83:
#line 405 "calculator.y" /* yacc.c:1652  */
    {    ino   = (int) (yyvsp[-10].dval);
                     frame = (int) (yyvsp[-7].dval);
                     x     = (int) (yyvsp[-4].dval);
                     y     = (int) (yyvsp[-1].dval);
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     {  bpp   = z[ino].bpp;
                        v = pixelat(z[ino].image[frame][y] + x*g.off[bpp], bpp); 
                        valuetoRGB(v,rr,gg,bb,bpp);
                        (yyval.dval) = (double)gg;
                     }else yyerror((char*)"Array out of bounds");
                }
#line 2227 "y.tab.c" /* yacc.c:1652  */
    break;

  case 84:
#line 420 "calculator.y" /* yacc.c:1652  */
    {    ino   = (int) (yyvsp[-10].dval);
                     frame = (int) (yyvsp[-7].dval);
                     x     = (int) (yyvsp[-4].dval);
                     y     = (int) (yyvsp[-1].dval);
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     {  bpp   = z[ino].bpp;
                        v = pixelat(z[ino].image[frame][y] + x*g.off[bpp], bpp); 
                        valuetoRGB(v,rr,gg,bb,bpp);
                        (yyval.dval) = (double)bb;
                     }else yyerror((char*)"Array out of bounds");
                }
#line 2246 "y.tab.c" /* yacc.c:1652  */
    break;

  case 85:
#line 435 "calculator.y" /* yacc.c:1652  */
    {    ino   = (int) (yyvsp[-7].dval);
                     x     = (int) (yyvsp[-4].dval);
                     y     = (int) (yyvsp[-1].dval);
                     if(between(ino, 0, g.image_count-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1) &&
                        z[ino].floatexists)
                          (yyval.dval) = z[ino].fft[y][x].real();
                     else yyerror((char*)"Array out of bounds");
                }
#line 2261 "y.tab.c" /* yacc.c:1652  */
    break;

  case 86:
#line 446 "calculator.y" /* yacc.c:1652  */
    {    ino   = (int) (yyvsp[-7].dval);
                     x     = (int) (yyvsp[-4].dval);
                     y     = (int) (yyvsp[-1].dval);
                     if(between(ino, 0, g.image_count-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1) &&
                        z[ino].floatexists)
                          (yyval.dval) = z[ino].fft[y][x].imag();
                     else yyerror((char*)"Array out of bounds");
                }
#line 2276 "y.tab.c" /* yacc.c:1652  */
    break;

  case 87:
#line 457 "calculator.y" /* yacc.c:1652  */
    {    ino   = (int) (yyvsp[-7].dval);
                     x     = (int) (yyvsp[-4].dval);
                     y     = (int) (yyvsp[-1].dval);
                     if(between(ino, 0, g.image_count-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1) &&
                        z[ino].waveletexists)
                          (yyval.dval) = z[ino].wavelet[y][x];
                     else yyerror((char*)"Array out of bounds");
                }
#line 2291 "y.tab.c" /* yacc.c:1652  */
    break;


#line 2295 "y.tab.c" /* yacc.c:1652  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_((char *)"syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_((char*)"memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 468 "calculator.y" /* yacc.c:1918  */



void initialize_evaluator(void)
{   
   /* 1-parameter functions - new functions can be added here */
   addfunc((char*)"abs",  fabs); 
   addfunc((char*)"acos", acos); 
   addfunc((char*)"asin", asin); 
   addfunc((char*)"atan", atan); 
   addfunc((char*)"cos",  cos); 
   addfunc((char*)"cosh", cosh); 
   addfunc((char*)"exp",  exp);
   addfunc((char*)"log",  log);
   addfunc((char*)"log10",log10);
   addfunc((char*)"rand", drand);
   addfunc((char*)"sin",  sin);
   addfunc((char*)"sinh", sinh);
   addfunc((char*)"sqrt", sqrt);
   addfunc((char*)"tan",  tan);
   addfunc((char*)"tanh", tanh);
   addfunc((char*)"erf",  erf);
   addfunc((char*)"spotsize", spot_size);
   addfunc((char*)"spotsignal", spot_signal);
   addfunc((char*)"spotx", spot_x); 
   addfunc((char*)"spoty", spot_y); 
   addfunc((char*)"pixels", pixels); 

#ifdef HAVE_ASINH
   addfunc((char*)"asinh",asinh); 
#endif
#ifdef HAVE_ACOSH
   addfunc((char*)"acosh",acosh); 
#endif
#ifdef HAVE_ATANH
   addfunc((char*)"atanh",atanh); 
#endif
#ifdef HAVE_CBRT
   addfunc((char*)"cbrt", cbrt); 
#endif

   /* 2-parameter functions - new functions can be added here */
   addfunc2((char*)"pow", pow); 
   addfunc2((char*)"min", dmin); 
   addfunc2((char*)"max", dmax); 

   /* 3-parameter functions - new functions can be added here */
   addfunc3((char*)"between", fbetween); 
   addfunc3((char*)"cdensity", cdensity); 

   /* 4-parameter functions - new functions can be added here */
   addfunc4((char*)"rdensity", rdensity); 

   /* functions with 1 string - new functions can be added here */
   addfuncchar((char*)"input", macro_double_input);

   addfuncchar2((char*)"getstring", macro_string_input);

   /* Functions that take a string as argument */
   /* To use this, change the YYSTRING entry from:
        |   YYSTRING  
                 {   len = strlen($1->name)-2;
                     strncpy(tempstring,$1->name+1,len);
                     tempstring[len]=0;
                     $$ = double_image_number(tempstring);
                 }
      to:
        |   NAME '(' YYSTRING ')' 
                 {
                    if($1-> char)
                    {   len = strlen($3->name)-2;
                        strncpy(tempstring,$3->name+1,len);
                        tempstring[len]=0;
                        $$ = ($1->funcptrchar)(tempstring);
                    }else
                    {   sprintf(tempstring, "Argument to %s is not a string\n", $1->name);
                        yyerror(tempstring);
                        $$ = 0.0;
                    }                    
     Can't have both because it causes a shift/reduce conflict.
   */
   /* addfuncchar((char*)"ino", double_image_number); */

   lineno = 0;
   yy_n_chars = 0;
}

void yyerror(char *s)
{  
   formula_error(s, text); 
   yyrestart(NULL);
}

void add_variable(char *name, double value)
{
   struct symtab *sp = symlook(name);
   sp->ptr = NULL;
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
   sp->value = value;
   sp->datatype = FLOAT;
}

/* Include a value so a number can be assoc. with string */
void add_string_variable(char *name, char *string, double value)
{
   if(string==NULL) return;
   struct symtab *sp = symlook(name);
   sp->ptr = NULL;
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
   sp->value = value;
   if(sp->string!=NULL) free(sp->string);
   sp->string = strdup(string);
   sp->datatype = STRING;
}

void add_pointer_variable(char *name, void *ptr)
{
   if(ptr==NULL) return;
   struct symtab *sp = symlook(name);
   sp->ptr = ptr;
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
   sp->value = 0;
   sp->datatype = POINTER;
}


void addfunc(char *name, double(*func)(double))
{
   struct symtab *sp = symlook(name);
   sp->ptr = NULL;
   sp->funcptr1 = func;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
}

void addfunc2(char *name, double(*func)(double, double))
{
   struct symtab *sp = symlook(name);
   sp->ptr = NULL;
   sp->funcptr1 = NULL;
   sp->funcptr2 = func;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
}

void addfunc3(char *name, double(*func)(double, double, double))
{
   struct symtab *sp = symlook(name);
   sp->ptr = NULL;
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = func;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
}

void addfunc4(char *name, double(*func)(double, double, double, double))
{
   struct symtab *sp = symlook(name);
   sp->ptr = NULL;
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = func;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
}

void addfuncchar(char *name, double(*func)(char *))
{
   struct symtab *sp = symlook(name);
   sp->ptr = NULL;
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = func;
   sp->funcptrchar2 = NULL;
}

void addfuncchar2(char *name, void(*func)(char*, char*))
{
   struct symtab *sp = symlook(name);
   sp->ptr = NULL;
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = func;
}



double read_variable(char *name, char *answer, int &datatype)
{
   struct symtab *sp = symlook(name);
   if(sp->datatype==STRING && answer != NULL)
   {   if(sp->string) strcpy(answer, sp->string); else answer[0]=0;
   }else
   datatype = sp->datatype;
   return sp->value;
}


void *read_ptr(char *name)
{
   struct symtab *sp = symlook(name);
   return sp->ptr;
}


struct symtab* symlook(char *s)
{
   struct symtab *sp;
   for(sp=symtab; sp< &symtab[NSYMS]; sp++)
   {  
       if(sp->name && !strcmp(sp->name, s)) return sp;  /* is it already here */
       if(!sp->name)                                    /* is it free         */
       {   sp->name = strdup(s); 
           sp->string = NULL;
           sp->datatype = NONE;
           return sp; 
       }
   }
   /* Make sure they don't know what to do */
   yyerror((char*)"Too many symbols, ask a wizard to enlarge me");
   return NULL;
}

void skip_to_end(void)
{
   while(strchr("\n ",yy_hold_char)!=NULL) yyinput(); 
   int got_left_brace = yy_hold_char=='{';
   if(got_left_brace)
   {   while(yy_hold_char != '}')
       {    yyinput();
            if(yy_hold_char==0) break;
       }
   }else
   {   while(strchr(";}\n",yy_hold_char)==NULL) yyinput(); 
   }
   yyinput();
   while(yy_hold_char=='\n') yyinput(); 
}

void skip_to_end_of_line(void)
{
   while(yy_hold_char != '\n' && yy_hold_char) yyinput(); 
   yyinput();
}

double dmax(double a, double b){ if(a>b) return a; return b; }
double dmin(double a, double b){ if(a<b) return a; return b; }
double drand(double a){ a=a; return rand()/(double)RAND_MAX; }

char *string(struct symtab *sym)
{
   static char sss[FILENAMELENGTH];
   len = strlen(sym->name)-2;
   strncpy(sss, sym->name+1, len);
   sss[len]=0;
   return sss;
}

void print_number(FILE *stream, double number) 
{
   fprintf(stream, "%g",number); 
   fflush(stream);
}

void print_string(FILE *stream, char *string)
{
   int j,k;
   char *s;
   int len = strlen(string);
   j=0;
   s = (char*) malloc(16384);
   for(k=0; k<len; k++) 
   {   if(k<len-1 && string[k]=='\\') switch(string[++k])
       {   case '0': s[j++] = '\0'; break;
           case 'a': s[j++] = '\a'; break;
           case 'b': s[j++] = '\b'; break;
           case 't': s[j++] = '\t'; break;
           case 'n': s[j++] = '\n'; break;
           case 'v': s[j++] = '\v'; break;
           case 'f': s[j++] = '\f'; break;
           case 'r': s[j++] = '\r'; break;
           case '\\': s[j++] = '\\'; break;
       }else s[j++] = string[k];
   }
   s[j] = 0;
   fprintf(stream, "%s",s);
   fflush(stream);
   free(s);
}
